<?php
	class Avalon_Custompaymentmethodtbigr_Model_Paymentmethod extends Mage_Payment_Model_Method_Abstract {
		protected $_code  = 'custompaymentmethodtbigr';
		protected $_formBlockType = 'custompaymentmethodtbigr/form_custompaymentmethodtbigr';
		protected $_infoBlockType = 'custompaymentmethodtbigr/info_custompaymentmethodtbigr';
		
		public function validate()
		{
			$paymentInfo = $this->getInfoInstance();
			if ($paymentInfo instanceof Mage_Sales_Model_Order_Payment) {
				$billingCountry = $paymentInfo->getOrder()->getBillingAddress()->getCountryId();
			} else {
				$billingCountry = $paymentInfo->getQuote()->getBillingAddress()->getCountryId();
			}
			if (!$this->canUseForCountry($billingCountry)) {
				Mage::throwException(Mage::helper('payment')->__('This payment method is not available in this country.'));
			}

			if (Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_unicid')){
				$tbigr_unicid = Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_unicid');
			}else{
				$tbigr_unicid = "";
			}
			$tbigr_ch = curl_init();
			curl_setopt($tbigr_ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($tbigr_ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($tbigr_ch, CURLOPT_URL, Mage::helper('custompaymentmethodtbigr')->getTbigrLiveUrl(). '/function/getparameters.php?cid='.$tbigr_unicid);
			$paramstbigr = json_decode(curl_exec($tbigr_ch), true);
			curl_close($tbigr_ch);
			
			$price = Mage::getModel('checkout/cart')->getQuote()->getGrandTotal();
			$tbigr_minprice_tbi = floatval($paramstbigr['tbi_minstojnost']);
			$tbigr_maxprice_tbi = floatval($paramstbigr['tbi_maxstojnost']);
			$tbigr_status_tbi = $paramstbigr['tbi_status'];
			
			if ($tbigr_status_tbi == 'No'){
				Mage::throwException(Mage::helper('payment')->__('You cannot use this payment method.'));
			}else{
				if ($price < $tbigr_minprice_tbi){
					Mage::throwException(Mage::helper('payment')->__('The amount of your order is less than the minimum allowed for this payment method - ' . $paramstbigr['tbi_minstojnost'] . '!.'));
				}else{
					if ($price > $tbigr_maxprice_tbi){
						Mage::throwException(Mage::helper('payment')->__('The amount of your order is greater than the maximum allowed for this payment method - ' . $paramstbigr['tbi_maxstojnost'] . '!.'));
					}
				}
			}
			
			return $this;
		}
		
		public function getOrderPlaceRedirectUrl()
		{
			if (Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_unicid')){
				$tbigr_unicid = Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_unicid');
			}else{
				$tbigr_unicid = "";
			}
			if (Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_store_id')){
				$tbigr_store_id = Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_store_id');
			}else{
				$tbigr_store_id = "";
			}	
			if (Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_username')){
				$tbigr_username = Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_username');
			}else{
				$tbigr_username = "";
			}	
			if (Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_password')){
				$tbigr_password = Mage::getStoreConfig('avalon_custompaymentmethodtbigr_tab_options/properties_all/grtbi_password');
			}else{
				$tbigr_password = "";
			}	
			
			$tbigr_mod_version = '';
			$tbigr_mod_version = Mage::getConfig()->getNode()->modules->Avalon_Custompaymentmethodtbigr->version;
			
			$quoteId = Mage::getSingleton('checkout/session')->getQuoteId();
			$quote = Mage::getModel("sales/quote")->load($quoteId);
			$quote_arr = $quote->getData();
			$billing_phone = $quote->getBillingAddress()->getTelephone();
			$billing_address = $quote->getBillingAddress()->getStreet(1) . ' ' . $quote->getBillingAddress()->getStreet(2);
			$billing_city = $quote->getBillingAddress()->getCity();
			$billing_country = $quote->getBillingAddress()->getData();
			$shipping_address = $quote->getShippingAddress()->getStreet(1) . ' ' . $quote->getShippingAddress()->getStreet(2);
			$shipping_city = $quote->getShippingAddress()->getCity();
			$shipping_country = $quote->getShippingAddress()->getData();
			
			$tbigr_ch = curl_init();
			curl_setopt($tbigr_ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($tbigr_ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($tbigr_ch, CURLOPT_URL, Mage::helper('custompaymentmethodtbigr')->getTbigrLiveUrl() . '/function/getparameters.php?cid='.$tbigr_unicid);
			$paramstbigr = json_decode(curl_exec($tbigr_ch), true);
			curl_close($tbigr_ch);    
			
			$tbigr_minprice_tbi = $paramstbigr['tbi_minstojnost'];
			$tbigr_theme = $paramstbigr['tbi_theme'];
			$tbigr_btn_theme = $paramstbigr['tbi_btn_theme'];
			$tbigr_custom_button_status = $paramstbigr['tbi_custom_button_status'];
			$tbigr_url = Mage::helper('custompaymentmethodtbigr')->getTbigrLiveUrl() . "/function/status.php";
			$tbigr_price_total = Mage::getModel('checkout/cart')->getQuote()->getGrandTotal();
			$tbigr_customer = Mage::helper('customer')->getCustomer()->getData();
			$tbigr_fname = isset($tbigr_customer['firstname']) ? $tbigr_customer['firstname'] : $quote_arr['customer_firstname'];
			$tbigr_lname = isset($tbigr_customer['lastname']) ? $tbigr_customer['lastname'] : $quote_arr['customer_lastname'];
			$tbigr_cnp = '';
			$tbigr_email = isset($tbigr_customer['email']) ? $tbigr_customer['email'] : $quote_arr['customer_email'];
			$customer_address = Mage::getModel('customer/customer')->load($tbigr_customer['entity_id']);
			$customerAddress = array();
			foreach ($customer_address->getAddresses() as $address){
				$customerAddress[] = $address->toArray();
			}
			$tbigr_billing_phone = isset($customerAddress[0]['telephone']) ? $customerAddress[0]['telephone'] : $billing_phone;
			$tbigr_billing_address = isset($customerAddress[0]['street']) ? $customerAddress[0]['street'] : $billing_address;
			$tbigr_billing_city = isset($customerAddress[0]['city']) ? $customerAddress[0]['city'] : $billing_city;
			$tbigr_billing_country = isset($customerAddress[0]['country_id']) ? $customerAddress[0]['country_id'] : $billing_country['region'];
			$tbigr_shipping_address = isset($customerAddress[0]['street']) ? $customerAddress[0]['street'] : $shipping_address;
			$tbigr_shipping_city = isset($customerAddress[0]['city']) ? $customerAddress[0]['city'] : $shipping_city;
			$tbigr_shipping_country = isset($customerAddress[0]['country_id']) ? $customerAddress[0]['country_id'] : $shipping_country['region'];
			$tbigr_person_type = '';
			$tbigr_net_income = '';
			$tbigr_instalments = '';
			
			$ident = 0;
			$tbigr_items = array();
			$tbigr_api_items = array();
			foreach(Mage::getModel('checkout/cart')->getQuote()->getAllItems() as $cart_item){
				if ($cart_item->getParentItemId()) {
					continue;
				}
				$tbigr_items[$ident]['name'] = $cart_item->getProduct()->getName();
				$tbigr_api_items[$ident]['name'] = $cart_item->getProduct()->getName();
				$tbigr_api_items[$ident]['description'] = '';
				$tbigr_quantity = $cart_item->getQty();
				$tbigr_items[$ident]['qty'] = "$tbigr_quantity";
				$tbigr_api_items[$ident]['qty'] = "$tbigr_quantity";
				$tbigr_price = (float)$cart_item->getPriceInclTax();
				$tbigr_items[$ident]['price'] = "$tbigr_price";
				$tbigr_api_items[$ident]['price'] = "$tbigr_price";
				$tbigr_product = Mage::getModel('catalog/product')->load($cart_item->getProductId());
				$cats = $tbigr_product->getCategoryIds();
				foreach ($cats as $cat_id){
					$tbigr_category = $cat_id;
				}
				$tbigr_items[$ident]['category'] = "$tbigr_category";
				$tbigr_product_id = $cart_item->getProductId();
				$tbigr_items[$ident]['sku'] = "$tbigr_product_id";
				$tbigr_api_items[$ident]['sku'] = "$tbigr_product_id";
				$tbigr_api_items[$ident]['category'] = "$tbigr_category";
				$tbigr_image = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_MEDIA) . 'catalog/product' . $tbigr_product->getImage();
				$tbigr_imagePath = isset($tbigr_image) ? $tbigr_image : '';
				$tbigr_items[$ident]['ImageLink'] = "$tbigr_imagePath";
				$tbigr_api_items[$ident]['ImageLink'] = "$tbigr_imagePath";
				$ident++;
			}
			
			$tbigr_orders = Mage::getModel('sales/order')->getCollection();
			$tbigr_orders->getSelect()->where("customer_email = '".$tbigr_email."'")->order('entity_id DESC')->limit('1');
			$tbigr_incrementId = $tbigr_orders->getLastItem()->getIncrementId();
			
			// Create tbigr order i data base
			$tbigr_add_ch = curl_init();
			curl_setopt($tbigr_add_ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($tbigr_add_ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($tbigr_add_ch, CURLOPT_URL, Mage::helper('custompaymentmethodtbigr')->getTbigrLiveUrl() . '/function/addorders.php?cid='.$tbigr_unicid);
			curl_setopt($tbigr_add_ch, CURLOPT_POST, 1);
			
			$tbigr_post = array(
				'store_id'      => $tbigr_store_id,
				'order_id'      =>  $tbigr_incrementId,
				'type'      	=>  'TBI',
				'back_ref'      =>  $tbigr_url,
				'order_total'   =>  $tbigr_price_total,
				'username'	=> $tbigr_username,
				'password'	=> $tbigr_password,
				'customer'      =>  array(
					'fname'         => $tbigr_fname,
					'lname'         => $tbigr_lname,
					'cnp'           => $tbigr_cnp, //$tbigr_cnp,
					'email'         => $tbigr_email,
					'phone'         => $tbigr_billing_phone,
					'billing_address'      => $tbigr_billing_address,
					'billing_city'          => $tbigr_billing_city,
					'billing_county'        => $tbigr_billing_country,
					'shipping_address'      => $tbigr_shipping_address,
					'shipping_city'          => $tbigr_shipping_city,
					'shipping_county'        => $tbigr_shipping_country,
					'person_type'   => $tbigr_person_type,
					'net_income'    => $tbigr_net_income,
					'instalments'	=> $tbigr_instalments
				),
				'items' => $tbigr_items
			);
			
			curl_setopt($tbigr_add_ch, CURLOPT_POSTFIELDS, http_build_query($tbigr_post));
			$paramstbigradd=json_decode(curl_exec($tbigr_add_ch), true);
			curl_close($tbigr_add_ch);				
			// Create tbigr order i data base
			
			if (isset($paramstbigradd['status']) && ($paramstbigradd['status'] == 'Yes')){
				// save to tbiorders file
				$resource = Mage::getSingleton('core/resource');
				$writeConnection = $resource->getConnection('core_write');
				$table = $resource->getTableName('sales_flat_order_grid');
				$new_tbigr_status = 'Draft';
				$query = "UPDATE {$table} SET tbigr_status = '{$new_tbigr_status}' WHERE increment_id = " . (int)$tbigr_incrementId;
				$writeConnection->query($query);

				// send to softinteligens
				$tbigr_post = array(
					'firstname'      	=> $tbigr_fname,
					'lastname'      	=> $tbigr_lname,
					'surname'      		=> '',
					'pin'   			=> $tbigr_cnp,
					'origin'			=> 'POS_Online',
					'resellercode'		=> $tbigr_store_id,
					'email'         	=> $tbigr_email,
					'phone'         	=> $tbigr_billing_phone,
					'billingaddress'	=> array(
						'country'			=> '',
						'county'        	=> $tbigr_billing_country,
						'city'         	 	=> $tbigr_billing_city,
						'streetname'      	=> $tbigr_billing_address,
						'streetno'			=> '',
						'buildingno'		=> '',
						'entranceno'		=> '',
						'floorno'			=> '',
						'apartmentno'		=> '',
						'postalcode'		=> ''
					),
					'deliveryaddress'	=> array(
						'country'			=> '',
						'county'        	=> $tbigr_shipping_country,
						'city'         	 	=> $tbigr_shipping_city,
						'streetname'      	=> $tbigr_shipping_address,
						'streetno'			=> '',
						'buildingno'		=> '',
						'entranceno'		=> '',
						'floorno'			=> '',
						'apartmentno'		=> '',
						'postalcode'		=> ''
					),
					'orderid'   		=> $paramstbigradd['newid'],
					'bankingproductcode'=> '',
					'promo'				=> '0',
					'installments'		=> $tbigr_instalments,
					'ordertotal'		=> $tbigr_price_total,
					'installmentamount'	=> '',
					'items' 			=> $tbigr_api_items,
					'siteurl'			=> Mage::helper('custompaymentmethodtbigr')->getTbigrLiveUrl(),
					'statusurl'			=> $tbigr_url
				);
				
				if ($paramstbigr['tbi_testenv'] == 1){
					$tbigr_envurl = $paramstbigr['tbi_testurl'];
					$tbigr_env = 'tbi_test';
				}else{
					$tbigr_envurl = $paramstbigr['tbi_liveurl'];
					$tbigr_env = 'tbi_live';
				}
				
				$tbi_pause_txt = $paramstbigr['tbi_pause_txt'];
				
				$_SESSION['send_tbigr'] = 'No';
				
				return Mage::getUrl('tbigrredirect', array('_query' => 'enc=' . base64_encode(json_encode($tbigr_post, JSON_UNESCAPED_UNICODE)) . '&envurl=' . $tbigr_envurl . '&tbi_pause_txt=' . $tbi_pause_txt . '&type=TBI' . '&tbigr_env=' . $tbigr_env));
			}
		}	
		
	}